=== modified file 'NEWS'
--- NEWS	2008-06-17 06:47:15 +0000
+++ NEWS	2008-06-19 06:57:22 +0000
@@ -16,6 +16,10 @@
 
   BUGFIXES:
 
+    * Handle urls such as ftp://user@host.com@www.host.com where the user
+      name contains an @.
+      (Neil Martinsen-Burrell, #228058)
+
     * ``needs_read_lock`` and ``needs_write_lock`` now suppress an error during
       ``unlock`` if there was an error in the original function. This helps
       most when there is a failure with a smart server action, since often the

=== modified file 'bzrlib/tests/test_transport.py'
--- bzrlib/tests/test_transport.py	2007-12-11 14:26:18 +0000
+++ bzrlib/tests/test_transport.py	2008-06-19 06:57:22 +0000
@@ -641,6 +641,11 @@
 
         self.assertEquals(t.base, 'http://simple.example.com/home/source/')
 
+    def test_parse_url_with_at_in_user(self):
+        # Bug 228058
+        t = ConnectedTransport('ftp://user@host.com@www.host.com/')
+        self.assertEquals(t._user, 'user@host.com')
+
     def test_parse_quoted_url(self):
         t = ConnectedTransport('http://ro%62ey:h%40t@ex%41mple.com:2222/path')
         self.assertEquals(t._host, 'exAmple.com')

=== modified file 'bzrlib/transport/__init__.py'
--- bzrlib/transport/__init__.py	2008-06-09 07:20:06 +0000
+++ bzrlib/transport/__init__.py	2008-06-19 06:57:22 +0000
@@ -1311,7 +1311,7 @@
          query, fragment) = urlparse.urlparse(url, allow_fragments=False)
         user = password = host = port = None
         if '@' in netloc:
-            user, host = netloc.split('@', 1)
+            user, host = netloc.rsplit('@', 1)
             if ':' in user:
                 user, password = user.split(':', 1)
                 password = urllib.unquote(password)

